/**
 * 
 * File: Main.java
 * 
 * This is the main class of the algorithm.
 * It gets the configuration script, builds the classifier and executes it.
 * 
 * @author Written by Joaqun Derrac (University of Granada) 21/06/2010 
 * @version 0.1 
 * @since JDK1.5
 * 
 */

package keel.Algorithms.FingerprintClassification.Shah04;

public class Main {
	
	//The classifier
	private static Shah04 classifier;
	
	/** 
	 * <p>
	 * The main method of the class
	 * </p> 
	 * 
	 * @param args Arguments of the program (a configuration script, generally)  
	 * 
	 */
	public static void main (String args[]) {
		
		if (args.length != 1){
			
			System.err.println("Error. A parameter is only needed.");
			
		} else {
			
			classifier = new Shah04(args[0]);
			classifier.generateModel();
			classifier.classifyTrain();
			classifier.classifyTest();
			classifier.printReport();
			
		}
		
	} //end-method 
  
} //end-class

