import java.util.*;

public class Confu {
	
  public static void main(String[] args) {
  
	int percentages;
	int confuTst[][][][];

    String cadena = "";
    StringTokenizer lineas, tokens;
    String linea, token;
    String dato1, dato2;
    boolean algorithms = true;
    Vector algoritmos, datasets, clasificadores;
    int i, h, j, k;
    String alAct, datAct, classAct;
    String cadenaSalida,nombreFichero;
    
    int numEjecuciones,numParticiones,metodos;

    Vector clases;

    if (args.length != 3) {
      System.err.println("Wrong parameters. Usage: <percentages> <configuration file> <number of partitions>");
      System.exit(1);
    }

    algoritmos = new Vector();
    datasets = new Vector();
    clasificadores = new Vector();

	percentages = Integer.parseInt(args[0]);    
	numParticiones = Integer.parseInt(args[2]);
	numEjecuciones = 1;
    
    /*Lectura del fichero de configuracin*/
    try{
    	cadena = Fichero.leeFichero(args[1]);
	}catch (java.io.IOException ex){
		ex.printStackTrace();
		System.exit(-1);
	}

	lineas = new StringTokenizer (cadena,"\n\r");
    while (lineas.hasMoreTokens()) {
      linea = lineas.nextToken();
      if (linea.equalsIgnoreCase("----"))
        algorithms = false;
      else {
        if (algorithms) {
          algoritmos.addElement(new String(linea));
        }
      }
    }
	datasets.addElement(".\\Experimento 1\\RedimDB1\\results\\");
	datasets.addElement(".\\Experimento 1\\RedimDB2\\results\\");
	datasets.addElement(".\\Experimento 1\\RedimDB3\\results\\");
	datasets.addElement(".\\Experimento 1\\RedimDB4\\results\\");
	datasets.addElement(".\\Experimento 1\\RedimDB5\\results\\");
    metodos = algoritmos.size();
	confuTst = new int [datasets.size()][metodos][5][5];
	clases = new Vector();
    cadenaSalida = new String("");
    
    /*Clculo de la matriz de confusion en cada clasificador*/
    
	for (i=0; i<5; i++) {
    	datAct = (String)datasets.elementAt(i);
    	System.err.println("Procesando Dataset: "+datAct);
    	for (j=0; j<metodos; j++) {
    		alAct = (String)algoritmos.elementAt(j);
    		System.err.println("Metodo: "+alAct);
			
			//vaciar matriz de confusion
			for(int a=0;a<4;a++){
				for(int b=0;b<4;b++){
					confuTst[i][j][a][b]=0;
				}
			}

							
    		for (k=0; k< numParticiones; k++) {
		    	clases.clear();
	    		try{
	    			cadena = Fichero.leeFichero(datAct+"\\"+alAct+"\\result"+k+"s0.tst");
				}catch(java.io.IOException e){
				    try{
						cadena = Fichero.leeFichero(datAct+"\\"+alAct+"\\result"+k+".tst");
				    }catch(java.io.IOException e2){
						e2.printStackTrace();
						System.exit(-1);							
					}
				}
	    		lineas = new StringTokenizer (cadena, "\n\r");
					
	    		//Leo la cabecera y guardo las clases:
	    		linea = lineas.nextToken();
	    		String linea2 = new String("");
		    	do{
			    	linea2 = linea;
	    			linea = lineas.nextToken();
    			}while(linea.startsWith("@attribute"));
					
    			//En linea2 tengo los valores para la clase
    			StringTokenizer clasesST = new StringTokenizer(linea2, "{,}"); 
    			linea = clasesST.nextToken(); //Leo el nombre
    			do{
	    			linea2 = clasesST.nextToken().trim();

	    			clases.add(linea2);
    			}while(clasesST.hasMoreTokens());
				
				lineas = new StringTokenizer (cadena, "\n\r");
					
	    		//Resto:
				linea = lineas.nextToken();
	    		while (lineas.hasMoreTokens()) {
		    		linea = lineas.nextToken();
	    			if (!(linea.startsWith("@"))) {
	    				tokens = new StringTokenizer (linea," ");
	    				dato1 = tokens.nextToken();
	    				dato2 = tokens.nextToken();
	    				int valor1 = clases.indexOf(dato1);	
	    				int valor2 = clases.indexOf(dato2); 
	    				confuTst[i][j][valor1][valor2]++;
    				}
	    		}
    		}//particiones
    	}//algoritmos
    }//datasets
	
	//imprimir la matriz por dataset y algoritmo
	for (i=0; i<datasets.size(); i++) {
		datAct = (String)datasets.elementAt(i);
		cadenaSalida+="\n\nDataset: "+datAct+"\n";
		for (j=0; j<metodos; j++) {
			alAct = (String)algoritmos.elementAt(j);
			cadenaSalida+="Metodo: "+alAct+"\n";
			cadenaSalida+="*******************************\n";
			for(int a=0;a<5;a++){
				for(int b=0;b<5;b++){
					cadenaSalida+=confuTst[i][j][a][b]+"\t";
				}	
				cadenaSalida+="\n";
			}
			cadenaSalida+="*******************************\n\n";
		}//algoritmos
    }//datasets
	
	Fichero.escribeFichero("confu.txt",cadenaSalida);

	//imprimir la matriz por grupo de datasets y algoritmo	
	
	int confuMed [][][] = new int [metodos][5][5];
	
	
	for (j=0; j<metodos; j++) {
		for(int a=0;a<5;a++){
			for(int b=0;b<5;b++){
				confuMed[j][a][b]=0;
			}
		}
	}
	
	for (i=0; i<datasets.size(); i++) {
		for (j=0; j<metodos; j++) {
			for(int a=0;a<5;a++){
				for(int b=0;b<5;b++){
					confuMed[j][a][b]+=confuTst[i][j][a][b];
				}
			}
		}
	}
    cadenaSalida = new String("");

	for (j=0; j<metodos; j++) {
		alAct = (String)algoritmos.elementAt(j);
		cadenaSalida+="Metodo: "+alAct+"\n";
		cadenaSalida+="*******************************\n";
		for(int a=0;a<5;a++){
			for(int b=0;b<5;b++){
				cadenaSalida+=confuMed[j][a][b]+"\t";
			}	
			cadenaSalida+="\n";
		}
		cadenaSalida+="*******************************\n\n";
	}//algoritmos

	
	Fichero.escribeFichero("confuMed.txt",cadenaSalida);
  }
}
