import Dataset.*;

public class Imputador{

	protected static InstanceSet train;
	protected static InstanceSet test;
	protected static Instance temp;
	protected static double values [][];
	protected static double averages [];
	protected static double averagesClass [][];
	protected static boolean [] nulls;
	protected static boolean [][] nullstra;
	
	protected static double [] correctos;
	protected static double [][] correctosClass;
	
	protected static double cleanvalues [][];
	
	private final static int ATTS = 816;
	private final static int CLAS = 5;
	
	public static void main(String args []){
		
		/*Lectura del fichero de training*/

		try {
			train = new InstanceSet();
			train.readSet(args[0], true);
			
	    } catch (Exception e) {
			System.err.println(e);
			System.exit(1);
	    }
		
		values = new double [train.getNumInstances()][ATTS];
		nullstra = new boolean [train.getNumInstances()][];
		correctos = new double[ATTS];
		correctosClass = new double[ATTS][CLAS];
		
		int clasesTrain [] = new int [train.getNumInstances()];
		
		for (int j=0; j<ATTS; j++) {
			correctos[j]=0.0;
			for (int k=0; k<CLAS; k++) {
				correctosClass[j][k]=0.0;
			}
		}
		
		for (int i=0; i<train.getNumInstances(); i++) {
		
	    	temp = train.getInstance(i);
			nullstra[i] = temp.getInputMissingValues();
			values[i] = temp.getAllInputValues();
			clasesTrain[i]=temp.getOutputNominalValuesInt(0);
		}
		
		averages= new double [ATTS];
		averagesClass= new double [ATTS][CLAS];
		for (int j=0; j<ATTS; j++) {
			averages[j]=0.0;
			for (int k=0; k<CLAS; k++) {
				averagesClass[j][k]=0.0;
			}
		}
		
		int cl;
		for (int i=0; i<train.getNumInstances(); i++) {
			cl=clasesTrain[i];
			for (int j=0; j<ATTS; j++) {
				if(nullstra[i][j]!=true){
					averages[j]+=values[i][j];
					correctos[j]+=1.0;
					averagesClass[j][cl]+=values[i][j];
					correctosClass[j][cl]+=1.0;
				}
			}
		}
		
		for (int j=0; j<ATTS; j++) {
			averages[j]/=correctos[j];
			for (int k=0; k<CLAS; k++) {
				if(correctosClass[j][k]>0){
					averagesClass[j][k]/=correctosClass[j][k];
				}
                                else{
                                    averagesClass[j][k] = (Attributes.getAttribute(j).getMaxAttribute() + Attributes.getAttribute(j).getMinAttribute()) / 2.0;
                                }
			}
		}
		
		for (int i=0; i<train.getNumInstances(); i++) {
		
	    	temp = train.getInstance(i);
			nulls = temp.getInputMissingValues();
			cl=clasesTrain[i];
			//Clean missing values
	        for (int j=0; j<nulls.length; j++){
	        	if (nulls[j]) {
	        		values[i][j]=averagesClass[j][cl];
		        }
	        }
	    }
		
		escribeSalida(args[2], values, clasesTrain, Attributes.getInputAttributes(), Attributes.getOutputAttribute(0), ATTS, "LeungCleaned");
		
		/*lectura del fichero de test*/
		Attributes.clearAll();
		try {
			test = new InstanceSet();
			test.readSet(args[1], true);
		    
			//Normalize the data
			
	    } catch (Exception e) {
			System.err.println(e);
			System.exit(1);
	    }
		
		cleanvalues = new double [test.getNumInstances()][ATTS];
		int clasesTest [] = new int [test.getNumInstances()];
		for (int i=0; i<test.getNumInstances(); i++) {
		
	    	temp = test.getInstance(i);
	    	cleanvalues[i] = temp.getAllInputValues();
			nulls = temp.getInputMissingValues();
			clasesTest[i]=test.getInstance(i).getOutputNominalValuesInt(0);
			//Clean missing values
	        for (int j=0; j<nulls.length; j++){
	        	if (nulls[j]) {
	        		cleanvalues[i][j]=averages[j];
		        }
	        }
	    }
	
		escribeSalida(args[3], cleanvalues, clasesTest, Attributes.getInputAttributes(), Attributes.getOutputAttribute(0), ATTS, "LeungCleaned");
		
	}
	
	/**
	 * Writes results
	 *
	 * @param nombreFichero Name of the output file
	 * @param instanciasIN Instances to write
	 * @param instanciasOUT Instances to mantain
	 * @param entradas Input attributes characteristics
	 * @param salida Output attribute characteristics
	 * @param nEntradas Number of input attributes
	 * @param relation Name of the data set
	 */
	public static void escribeSalida (String nombreFichero, double instanciasIN[][], int instanciasOUT[], Attribute entradas[], Attribute salida, int nEntradas, String relation) {

		String cadena = "";
		int i, j;
		int aux;

		/*Printing input attributes*/
		cadena += "@relation "+ relation +"\n";
		for (i=0; i<nEntradas; i++) {
		  cadena += "@attribute "+ entradas[i].getName()+" ";
		  if (entradas[i].getType() == Attribute.NOMINAL) {
			cadena += "{";
			for (j=0; j<entradas[i].getNominalValuesList().size(); j++) {
			  cadena += (String)entradas[i].getNominalValuesList().elementAt(j);
			  if (j < entradas[i].getNominalValuesList().size() -1) {
				cadena += ", ";
			  }
			}
			cadena += "}\n";
		  } else {
			if (entradas[i].getType() == Attribute.INTEGER) {
			  cadena += "integer";
			  cadena += " ["+String.valueOf((int)entradas[i].getMinAttribute()) + ", " +  String.valueOf((int)entradas[i].getMaxAttribute())+"]\n";
			} else {
			  cadena += "real";
			  cadena += " ["+String.valueOf(entradas[i].getMinAttribute()) + ", " +  String.valueOf(entradas[i].getMaxAttribute())+"]\n";
			}
		  }
		}

		/*Printing output attribute*/
		cadena += "@attribute "+ salida.getName()+" ";
		if (salida.getType() == Attribute.NOMINAL) {
		  cadena += "{";
		  for (j=0; j<salida.getNominalValuesList().size(); j++) {
			cadena += (String)salida.getNominalValuesList().elementAt(j);
			if (j < salida.getNominalValuesList().size() -1) {
			  cadena += ", ";
			}
		  }
		  cadena += "}\n";
		} else {
		  cadena += "integer ["+String.valueOf((int)salida.getMinAttribute()) + ", " + String.valueOf((int)salida.getMaxAttribute())+"]\n";
		}

		/*Printing the data*/
		cadena += "@data\n";

		Fichero.escribeFichero (nombreFichero, cadena);
		for (i=0; i<instanciasIN.length; i++) {
		  cadena = "";
		  for (j=0; j<instanciasIN[i].length; j++) {
			if (entradas[j].getType() == Attribute.REAL) {
			  String number = String.valueOf(instanciasIN[i][j]);
			  String comma[] = number.split("\\.");
			  if (comma.length > 1) {
				int pos1, pos2;
				if (comma[1].indexOf("E") < 0) {
				  pos1 = comma[1].indexOf("0000");
				  pos2 = comma[1].indexOf("9999");
				  if (pos1 >= 0) {
					comma[1] = comma[1].substring(0,pos1);
				   if (comma[1].length() == 0) comma[1] = "0";
				  } else if (pos2 >= 0) {
					comma[1] = comma[1].substring(0,pos2);

					if (comma[1].length() == 0) {
					  comma[1] = "0";
					  int redondo = Integer.parseInt(comma[0]);
					  redondo++;
					  comma[0] = String.valueOf(redondo);
					} else {
					  long redondo = Long.parseLong(comma[1].substring(comma[1].length()-1));
					  redondo++;
					  comma[1] = comma[1].substring(0,comma[1].length()-1) + String.valueOf(redondo);
					}
				  }
				}
				cadena +=  comma[0] + "." + comma[1] + ",";
			  } else {
				cadena +=  comma[0] + ",";		  
			  }
			} else if (Attributes.getInputAttribute(j).getType() == Attribute.INTEGER) {
			  cadena += String.valueOf((int)((instanciasIN[i][j]*(entradas[j].getMaxAttribute()-entradas[j].getMinAttribute())) + entradas[j].getMinAttribute())) + ",";
			} else {
			  aux = (int) (instanciasIN[i][j] * (entradas[j].getNominalValuesList().size() - 1));
			  cadena += (String)entradas[j].getNominalValuesList().elementAt(aux) + ",";
			}
		  }
		  if (salida.getType() == Attribute.INTEGER) {
			cadena += String.valueOf(instanciasOUT[i]);
		  } else {
			cadena += (String)salida.getNominalValuesList().elementAt(instanciasOUT[i]);
		  }

		  cadena += "\n";
		  Fichero.AnadirtoFichero (nombreFichero, cadena);
		}
		
    }//end-method

}